#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    int n, q;
    cin >> n >> q;
    vector<int>a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    vector<int>b(n, 0);
    for(int i = 0; i < n; i++){
        while(a[i] > 1){
            a[i] /= 2;
            b[i]++;
        }
    }
    vector<vector<int>>c(n, vector<int>(30, 0));
    for(int i = 0; i < n; i++){
        for(int j = 0; j <= i; j++){
            c[i][b[j]]++;
        }
    }
        
    for(int i = 0; i < q; i++){
        int l, r, max = 1;
        cin >> l >> r;
        l--; r--;
        for(int j = 0; j < 30; j++){
            if(c[r][j]-c[l][j] > max){
                max = c[r][j]-c[l][j];
            }
        }
        cout << max << '\n'; 
    }
    return 0;
}